/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/css!vs/workbench/parts/markers/browser/media/markers",["vs/css!vs/workbench/parts/markers/browser/markersPanel"],{}),define("vs/nls!vs/workbench/parts/markers/browser/markersActionProvider",["vs/nls","vs/nls!vs/workbench/parts/markers/browser/markersPanel"],function(e,t){return e.create("vs/workbench/parts/markers/browser/markersActionProvider",t)}),define("vs/workbench/parts/markers/common/markersModel",["require","exports","vs/base/common/strings","vs/base/common/paths","vs/base/common/types","vs/base/common/map","vs/base/common/severity","vs/base/common/uri","vs/editor/common/core/range","vs/base/common/filters","vs/workbench/parts/markers/common/messages"],function(e,t,r,s,n,o,i,a,c,u,l){"use strict";var p=function(){function e(e,t,r,n){void 0===n&&(n=[]),this.uri=e,this.markers=t,this.statistics=r,this.matches=n,this.path=e.fsPath,this.name=s.basename(e.fsPath)}return e}();t.Resource=p;var h=function(){function e(e,t,r,s){void 0===r&&(r=[]),void 0===s&&(s=[]),this.id=e,this.marker=t,this.labelMatches=r,this.sourceMatches=s}return e}();t.Marker=h;var f=function(){function e(e){void 0===e&&(e=""),this._filterErrors=!1,this._filterWarnings=!1,this._filterInfos=!1,this._filter="",this._completeFilter="",e&&this.parse(e)}return Object.defineProperty(e.prototype,"filterErrors",{get:function(){return this._filterErrors},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filterWarnings",{get:function(){return this._filterWarnings},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filterInfos",{get:function(){return this._filterInfos},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filter",{get:function(){return this._filter},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"completeFilter",{get:function(){return this._completeFilter},enumerable:!0,configurable:!0}),e.prototype.hasFilters=function(){return!!this._filter},e.prototype.parse=function(e){this._completeFilter=e,this._filter=e.trim(),this._filterErrors=this.matches(this._filter,l["default"].MARKERS_PANEL_FILTER_ERRORS),this._filterWarnings=this.matches(this._filter,l["default"].MARKERS_PANEL_FILTER_WARNINGS),this._filterInfos=this.matches(this._filter,l["default"].MARKERS_PANEL_FILTER_INFOS)},e.prototype.matches=function(e,t){var r=u.matchesPrefix(e,t);return r&&r.length>0},e._filter=u.or(u.matchesPrefix,u.matchesContiguousSubString),e._fuzzyFilter=u.or(u.matchesPrefix,u.matchesContiguousSubString,u.matchesFuzzy),e}();t.FilterOptions=f;var m=function(){function e(e){void 0===e&&(e=[]),this.markersByResource=new o.SimpleMap,this._filterOptions=new f,this.update(e)}return Object.defineProperty(e.prototype,"filterOptions",{get:function(){return this._filterOptions},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filteredResources",{get:function(){return this._filteredResources},enumerable:!0,configurable:!0}),e.prototype.hasFilteredResources=function(){return this.filteredResources.length>0},e.prototype.hasResources=function(){return this.markersByResource.size>0},e.prototype.hasResource=function(e){return this.markersByResource.has(e)},Object.defineProperty(e.prototype,"nonFilteredResources",{get:function(){return this._nonFilteredResources},enumerable:!0,configurable:!0}),e.prototype.update=function(e,t){e instanceof f&&(this._filterOptions=e),e instanceof a["default"]&&this.updateResource(e,t),n.isArray(e)&&this.updateMarkers(e),this.refresh()},e.prototype.refresh=function(){this.refreshResources()},e.prototype.refreshResources=function(){var e=this.markersByResource.entries().map(this.toFilteredResource.bind(this));this._nonFilteredResources=e.filter(function(e){return 0===e.markers.length}),this._filteredResources=e.filter(function(e){return e.markers.length>0}),this._filteredResources.sort(function(e,t){return 0===e.statistics.errors&&t.statistics.errors>0?1:0===t.statistics.errors&&e.statistics.errors>0?-1:r.localeCompare(e.path,t.path)||r.localeCompare(e.name,t.name)})},e.prototype.updateResource=function(e,t){this.markersByResource.has(e)&&this.markersByResource["delete"](e),t.length>0&&this.markersByResource.set(e,t)},e.prototype.updateMarkers=function(e){var t=this;e.forEach(function(e){var r=e.resource,s=t.markersByResource.get(r);s||(s=[],t.markersByResource.set(r,s)),s.push(e)})},e.prototype.toFilteredResource=function(e){var t=this,r=e.value.filter(this.filterMarker.bind(this)).map(function(e,r){return t.toMarker(e,r)});r.sort(this.compareMarkers.bind(this));var n=f._filter(this._filterOptions.filter,s.basename(e.key.fsPath));return new p(e.key,r,this.getStatistics(e.value),n||[])},e.prototype.toMarker=function(e,t){var r=f._fuzzyFilter(this._filterOptions.filter,e.message),s=e.source?f._filter(this._filterOptions.filter,e.source):[];return new h(e.resource.toString()+t,e,r||[],s||[])},e.prototype.filterMarker=function(e){return this._filterOptions.filter?this._filterOptions.filterErrors&&i["default"].Error===e.severity?!0:this._filterOptions.filterWarnings&&i["default"].Warning===e.severity?!0:this._filterOptions.filterInfos&&i["default"].Info===e.severity?!0:f._fuzzyFilter(this._filterOptions.filter,e.message)?!0:f._filter(this._filterOptions.filter,s.basename(e.resource.fsPath))?!0:!(!e.source||!f._filter(this._filterOptions.filter,e.source)):!0},e.prototype.compareMarkers=function(e,t){return c.Range.compareRangesUsingStarts({startLineNumber:e.marker.startLineNumber,startColumn:e.marker.startColumn,endLineNumber:e.marker.endLineNumber,endColumn:e.marker.endColumn},{startLineNumber:t.marker.startLineNumber,startColumn:t.marker.startColumn,endLineNumber:t.marker.endLineNumber,endColumn:t.marker.endColumn})},e.prototype.getStatistics=function(e){var t=0,r=0,s=0,n=0;return e.forEach(function(e){switch(e.severity){case i["default"].Error:return void t++;case i["default"].Warning:return void r++;case i["default"].Info:return void s++;default:return void n++}}),{errors:t,warnings:r,infos:s,unknwons:n}},e.prototype.getTitle=function(t){var r=e.getStatisticsLabel(t);return r?r:l["default"].MARKERS_PANEL_TITLE_NO_PROBLEMS},e.prototype.getMessage=function(){return this.hasFilteredResources()?"":this.hasResources()&&this._filterOptions.hasFilters()?l["default"].MARKERS_PANEL_NO_PROBLEMS_FILTERS:l["default"].MARKERS_PANEL_NO_PROBLEMS_BUILT},e.getStatisticsLabel=function(e,t){void 0===t&&(t=!1);var r=this.getLabel("",e.errors,l["default"].MARKERS_PANEL_SINGLE_ERROR_LABEL,l["default"].MARKERS_PANEL_MULTIPLE_ERRORS_LABEL);return t||(r=this.getLabel(r,e.warnings,l["default"].MARKERS_PANEL_SINGLE_WARNING_LABEL,l["default"].MARKERS_PANEL_MULTIPLE_WARNINGS_LABEL),r=this.getLabel(r,e.infos,l["default"].MARKERS_PANEL_SINGLE_INFO_LABEL,l["default"].MARKERS_PANEL_MULTIPLE_INFOS_LABEL),r=this.getLabel(r,e.unknwons,l["default"].MARKERS_PANEL_SINGLE_UNKNOWN_LABEL,l["default"].MARKERS_PANEL_MULTIPLE_UNKNOWNS_LABEL)),r},e.getLabel=function(e,t,r,s){return 0>=t?e:(e=e?e+", ":"",e+=1===t?r:s(t))},e}();t.MarkersModel=m});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},__decorate=this&&this.__decorate||function(e,t,r,s){var n,o=arguments.length,i=3>o?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,t,r,s);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(i=(3>o?n(i):o>3?n(t,r,i):n(t,r))||i);return o>3&&i&&Object.defineProperty(t,r,i),i},__param=this&&this.__param||function(e,t){return function(r,s){t(r,s,e)}};define("vs/workbench/parts/markers/browser/markersActionProvider",["require","exports","vs/nls!vs/workbench/parts/markers/browser/markersActionProvider","vs/base/common/winjs.base","vs/base/common/actions","vs/platform/instantiation/common/instantiation","vs/workbench/parts/markers/common/markersModel"],function(e,t,r,s,n,o,i){"use strict";var a=function(e){function t(){e.call(this,"remove",r.localize(0,null),"action-remove")}return __extends(t,e),t.prototype.run=function(e){return e.tree.refresh()},t}(n.Action),c=function(){function e(e){this.cache={},this.instantiationService=e}return e.prototype.getAction=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];var s=this.cache[e.ID];return s||(t.unshift(e),s=this.cache[e.ID]=this.instantiationService.createInstance.apply(this.instantiationService,t)),s},e.prototype.dispose=function(){var e=this;Object.keys(this.cache).forEach(function(t){e.cache[t].dispose()}),this.cache=null},e}();t.ActionContainer=c;var u=function(e){function t(t){e.call(this,t)}return __extends(t,e),t.prototype.hasActions=function(e,t){return t instanceof i.Resource},t.prototype.getActions=function(e,t){return s.TPromise.as(this.getActionsForResource())},t.prototype.getActionsForResource=function(){return[new a]},t.prototype.hasSecondaryActions=function(e,t){return!1},t.prototype.getSecondaryActions=function(e,t){return s.TPromise.as([])},t.prototype.getActionItem=function(e,t,r){return null},t=__decorate([__param(0,o.IInstantiationService)],t)}(c);t.ActionProvider=u});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},__decorate=this&&this.__decorate||function(e,t,r,s){var n,o=arguments.length,i=3>o?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,t,r,s);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(i=(3>o?n(i):o>3?n(t,r,i):n(t,r))||i);return o>3&&i&&Object.defineProperty(t,r,i),i},__param=this&&this.__param||function(e,t){return function(r,s){t(r,s,e)}};define("vs/workbench/parts/markers/browser/markersPanelActions",["require","exports","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/actions","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/common/keyCodes","vs/platform/contextview/browser/contextView","vs/workbench/parts/markers/common/messages","vs/workbench/parts/markers/common/markersModel"],function(e,t,r,s,n,o,i,a,c,u,l){"use strict";var p=function(e){function t(t){e.call(this,"workbench.markers.panel.action.filter",u["default"].MARKERS_PANEL_ACTION_TOOLTIP_FILTER,"markers-panel-action-filter",!0),this.markersPanel=t}return __extends(t,e),t}(n.Action);t.FilterAction=p;var h=function(e){function t(t,r,s){e.call(this,t,r),this.markersPanel=t,this.contextViewService=s,this.toDispose=[]}return __extends(t,e),t.prototype.render=function(e){var t=this;r.addClass(e,"markers-panel-action-filter");var s=new i.InputBox(e,this.contextViewService,{placeholder:u["default"].MARKERS_PANEL_FILTER_PLACEHOLDER,ariaLabel:u["default"].MARKERS_PANEL_FILTER_PLACEHOLDER});s.value=this.markersPanel.markersModel.filterOptions.completeFilter,this.toDispose.push(s.onDidChange(function(e){t.markersPanel.markersModel.update(new l.FilterOptions(e)),t.markersPanel.refreshPanel()})),this.toDispose.push(r.addStandardDisposableListener(e,"keydown",this.handleKeyboardEvent)),this.toDispose.push(r.addStandardDisposableListener(e,"keyup",this.handleKeyboardEvent))},t.prototype.dispose=function(){this.toDispose=s.dispose(this.toDispose),e.prototype.dispose.call(this)},t.prototype.handleKeyboardEvent=function(e){switch(e.keyCode){case a.CommonKeybindings.SPACE:case a.CommonKeybindings.LEFT_ARROW:case a.CommonKeybindings.RIGHT_ARROW:e.stopPropagation()}},t=__decorate([__param(2,c.IContextViewService)],t)}(o.BaseActionItem);t.FilterInputBoxActionItem=h});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},__decorate=this&&this.__decorate||function(e,t,r,s){var n,o=arguments.length,i=3>o?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,t,r,s);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(i=(3>o?n(i):o>3?n(t,r,i):n(t,r))||i);return o>3&&i&&Object.defineProperty(t,r,i),i},__param=this&&this.__param||function(e,t){return function(r,s){t(r,s,e)}};define("vs/workbench/parts/markers/browser/markersTreeController",["require","exports","vs/base/common/errors","vs/base/parts/tree/browser/treeDefaults","vs/workbench/parts/markers/common/markersModel","vs/workbench/services/editor/common/editorService"],function(e,t,r,s,n,o){"use strict";var i=function(e){function t(t){e.call(this),this.editorService=t}return __extends(t,e),t.prototype.onLeftClick=function(t,r,s){var o=t.getFocus();if(e.prototype.onLeftClick.call(this,t,r,s)){if(this.openFileAtElement(r,2!==s.detail,s.ctrlKey))return!0;if(r instanceof n.MarkersModel)return o?t.setFocus(o):t.focusFirst(),!0}return!1},t.prototype.onEnter=function(t,r){return e.prototype.onEnter.call(this,t,r)?this.openFileAtElement(t.getFocus(),!1,!1):!1},t.prototype.openFileAtElement=function(e,t,s){if(e instanceof n.Marker){var o=e.marker;return this.editorService.openEditor({resource:o.resource,options:{selection:{startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn},preserveFocus:t}},s).done(null,r.onUnexpectedError),!0}return!1},t=__decorate([__param(0,o.IWorkbenchEditorService)],t)}(s.DefaultController);t.Controller=i});var __decorate=this&&this.__decorate||function(e,t,r,s){var n,o=arguments.length,i=3>o?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,t,r,s);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(i=(3>o?n(i):o>3?n(t,r,i):n(t,r))||i);return o>3&&i&&Object.defineProperty(t,r,i),i},__param=this&&this.__param||function(e,t){return function(r,s){t(r,s,e)}};define("vs/workbench/parts/markers/browser/markersTreeViewer",["require","exports","vs/base/common/winjs.base","vs/base/browser/dom","vs/base/common/severity","vs/workbench/services/workspace/common/contextService","vs/base/browser/ui/countBadge/countBadge","vs/base/browser/ui/fileLabel/fileLabel","vs/base/browser/ui/highlightedlabel/highlightedLabel","vs/workbench/parts/markers/common/markersModel","vs/workbench/parts/markers/common/messages"],function(e,t,r,s,n,o,i,a,c,u,l){"use strict";var p=function(){function e(){}return e.prototype.getId=function(e,t){return t instanceof u.MarkersModel?"root":t instanceof u.Resource?t.uri.toString():t instanceof u.Marker?t.id:""},e.prototype.hasChildren=function(e,t){return t instanceof u.MarkersModel||t instanceof u.Resource},e.prototype.getChildren=function(e,t){return t instanceof u.MarkersModel?r.TPromise.as(t.filteredResources):t instanceof u.Resource?r.TPromise.as(t.markers):null},e.prototype.getParent=function(e,t){return r.TPromise.as(null)},e}();t.DataSource=p;var h=function(){function e(e,t,r){this.actionRunner=e,this.actionProvider=t,this.contextService=r}return e.prototype.getHeight=function(e,t){return 22},e.prototype.getTemplateId=function(t,r){return r instanceof u.Resource?e.RESOURCE_TEMPLATE_ID:r instanceof u.Marker?e.MARKER_TEMPLATE_ID:""},e.prototype.renderTemplate=function(t,r,n){switch(s.addClass(n,"markers-panel-tree-entry"),r){case e.RESOURCE_TEMPLATE_ID:return this.renderResourceTemplate(n);case e.MARKER_TEMPLATE_ID:return this.renderMarkerTemplate(n)}},e.prototype.renderResourceTemplate=function(e){var t=Object.create(null),r=s.append(e,s.emmet(".resource-label-container"));t.file=new a.FileLabel(r,null,this.contextService);var n=s.append(e,s.emmet(".count-badge-wrapper"));return t.count=new i.CountBadge(n),t},e.prototype.renderMarkerTemplate=function(e){var t=Object.create(null);return t.icon=s.append(e,s.emmet(".marker-icon")),t.description=new c.HighlightedLabel(s.append(e,s.emmet(".marker-description"))),t.lnCol=s.append(e,s.emmet("span.marker-line")),t.source=new c.HighlightedLabel(s.append(e,s.emmet(".marker-source"))),t},e.prototype.renderElement=function(t,r,s,n){switch(s){case e.RESOURCE_TEMPLATE_ID:return this.renderResourceElement(t,r,n);case e.MARKER_TEMPLATE_ID:return this.renderMarkerElement(t,r,n)}},e.prototype.renderResourceElement=function(e,t,r){r.file.setValue(t.uri,t.matches),r.count.setCount(t.markers.length)},e.prototype.renderMarkerElement=function(t,r,s){var n=r.marker;s.icon.className="icon "+e.iconClassNameFor(n),s.description.set(n.message,r.labelMatches),s.lnCol.textContent=l["default"].MARKERS_PANEL_AT_LINE_COL_NUMBER(n.startLineNumber,n.startColumn);var o=l["default"].MARKERS_PANEL_TITLE_AT_LINE_COL_NUMBER(n.startLineNumber,n.startColumn);if(s.lnCol.title=o,s.lnCol.setAttribute("aria-label",o),n.source){s.source.set(n.source,r.sourceMatches);var i=l["default"].MARKERS_PANEL_TITLE_SOURCE(n.source);s.source.element.title=i,s.source.element.setAttribute("aria-label",i)}},e.iconClassNameFor=function(e){switch(e.severity){case n["default"].Ignore:return"info";case n["default"].Info:return"info";case n["default"].Warning:return"warning";case n["default"].Error:return"error"}return""},e.prototype.disposeTemplate=function(e,t,r){},e.RESOURCE_TEMPLATE_ID="resource-template",e.MARKER_TEMPLATE_ID="marker-template",e=__decorate([__param(2,o.IWorkspaceContextService)],e)}();t.Renderer=h});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},__decorate=this&&this.__decorate||function(e,t,r,s){var n,o=arguments.length,i=3>o?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,t,r,s);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(i=(3>o?n(i):o>3?n(t,r,i):n(t,r))||i);return o>3&&i&&Object.defineProperty(t,r,i),i},__param=this&&this.__param||function(e,t){return function(r,s){t(r,s,e)}};define("vs/workbench/parts/markers/browser/markersPanel",["require","exports","vs/base/common/errors","vs/base/common/set","vs/base/common/winjs.base","vs/base/common/async","vs/base/browser/dom","vs/base/common/lifecycle","vs/platform/markers/common/markers","vs/platform/telemetry/common/telemetry","vs/platform/event/common/event","vs/workbench/browser/panel","vs/workbench/services/editor/common/editorService","vs/workbench/parts/markers/common/constants","vs/workbench/parts/markers/common/markersModel","vs/workbench/parts/markers/browser/markersTreeController","vs/base/parts/tree/browser/treeDefaults","vs/base/parts/tree/browser/treeImpl","vs/workbench/parts/markers/browser/markersTreeViewer","vs/platform/instantiation/common/instantiation","vs/workbench/parts/markers/browser/markersActionProvider","vs/workbench/parts/markers/browser/markersPanelActions","vs/css!./media/markers"],function(e,t,r,s,n,o,i,a,c,u,l,p,h,f,m,d,_,v,b,k,y,R){"use strict";var E=function(e){function t(t,r,n,i,a){e.call(this,f["default"].MARKERS_PANEL_ID,a),this.instantiationService=t,this.markerService=r,this.editorService=n,this.eventService=i,this.markersModel=new m.MarkersModel,this.toDispose=[],this.delayedRefresh=new o.Delayer(1e3),this.autoExpanded=new s.ArraySet}return __extends(t,e),t.prototype.create=function(t){e.prototype.create.call(this,t),i.addClass(t.getHTMLElement(),"markers-panel");var r=i.append(t.getHTMLElement(),i.emmet(".markers-panel-container"));return this.createMessageBox(r),this.createTree(r),this.createActions(),this.createListeners(),this.render(),n.TPromise.as(null)},t.prototype.getTitle=function(){var e=this.markerService.getStatistics();return this.markersModel.getTitle(e)},t.prototype.layout=function(e){this.tree.layout(e.height)},t.prototype.focus=function(){this.markersModel.hasFilteredResources()&&(this.tree.DOMFocus(),this.tree.getFocus()||this.tree.focusFirst())},t.prototype.getActions=function(){return this.collapseAllAction.enabled=this.markersModel.hasFilteredResources(),this.actions},t.prototype.refreshPanel=function(e){var t=this;return void 0===e&&(e=!1),this.collapseAllAction.enabled=this.markersModel.hasFilteredResources(),this.refreshAutoExpanded(),e&&this.updateTitleArea(),i.toggleClass(this.treeContainer,"hidden",!this.markersModel.hasFilteredResources()),this.renderMessage(),this.markersModel.hasFilteredResources()?this.tree.refresh().then(function(){t.autoExpand()}):n.TPromise.as(null)},t.prototype.createMessageBox=function(e){this.messageBoxContainer=i.append(e,i.emmet(".message-box-container")),this.messageBox=i.append(this.messageBoxContainer,i.emmet("p"))},t.prototype.createTree=function(e){this.treeContainer=i.append(e,i.emmet(".tree-container"));var t=this.instantiationService.createInstance(y.ActionProvider),r=this.instantiationService.createInstance(b.Renderer,this.getActionRunner(),t),s=this.instantiationService.createInstance(d.Controller);this.tree=new v.Tree(this.treeContainer,{dataSource:new b.DataSource,renderer:r,controller:s},{indentPixels:0,twistiePixels:20})},t.prototype.createActions=function(){var e=this;this.collapseAllAction=this.instantiationService.createInstance(_.CollapseAllAction,this.tree,!0),this.filterAction=new R.FilterAction(this),this.actions=[this.filterAction,this.collapseAllAction],this.actions.forEach(function(t){e.toDispose.push(t)})},t.prototype.createListeners=function(){this.toDispose.push(this.markerService.onMarkerChanged(this.onMarkerChanged.bind(this)))},t.prototype.onMarkerChanged=function(e){this.updateResources(e),this.refreshPanel(!0)},t.prototype.updateResources=function(e){var t=this;e.forEach(function(e){var r=t.markerService.read({resource:e}).slice(0);t.markersModel.update(e,r),t.markersModel.hasResource(e)||t.autoExpanded.unset(e.toString())})},t.prototype.render=function(){var e=this.markerService.read().slice(0);this.markersModel.update(e),this.tree.setInput(this.markersModel).then(this.autoExpand.bind(this)),i.toggleClass(this.treeContainer,"hidden",!this.markersModel.hasFilteredResources()),this.renderMessage()},t.prototype.renderMessage=function(){var e=this.markersModel.getMessage();this.messageBox.textContent=e,i.toggleClass(this.messageBoxContainer,"hidden",this.markersModel.hasFilteredResources())},t.prototype.refreshAutoExpanded=function(){var e=this;this.markersModel.nonFilteredResources.forEach(function(t){e.tree.isExpanded(t)&&e.autoExpanded.unset(t.uri.toString())})},t.prototype.autoExpand=function(){var e=this;this.markersModel.filteredResources.forEach(function(t){e.autoExpanded.contains(t.uri.toString())||(e.tree.expand(t).done(null,r.onUnexpectedError),e.autoExpanded.set(t.uri.toString()))})},t.prototype.getActionItem=function(t){return"workbench.markers.panel.action.filter"===t.id?this.instantiationService.createInstance(R.FilterInputBoxActionItem,this,t):e.prototype.getActionItem.call(this,t)},t.prototype.dispose=function(){this.delayedRefresh.cancel(),this.toDispose=a.dispose(this.toDispose),e.prototype.dispose.call(this)},t=__decorate([__param(0,k.IInstantiationService),__param(1,c.IMarkerService),__param(2,h.IWorkbenchEditorService),__param(3,l.IEventService),__param(4,u.ITelemetryService)],t)}(p.Panel);t.MarkersPanel=E});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2481a7dad82f8e8d105c5329b4b6f20e15e9b27c/vs/workbench/parts/markers/browser/markersPanel.js.map
